uniform sampler2D buffer1;
uniform sampler2D buffer2;

uniform vec4 skyColor;
uniform vec4 groundColor;

varying vec3 transformedNorthPole;

void main (void)
{
	vec4 element1 = texture2D(buffer1, gl_TexCoord[0].xy);
	vec3 normal = texture2D(buffer2,gl_TexCoord[0].xy).xyz;
		
	gl_FragColor = vec4(element1.xyz*element1.w,0);
	
	if (length(normal) > 0)
	{
		normal = normalize(normal);
		
		float cosPhi = dot(normal, transformedNorthPole);
		
		float a = 0.5 + (0.5*dot(normal, transformedNorthPole));

		gl_FragColor += mix(groundColor, skyColor,a)* vec4(element1.xyz,0);
	}
}


